#
# $Source: /home/nlfm/Working/Zircon/Released/lib/RCS/Monitor.tcl,v $
# $Date: 1997/05/09 10:20:42 $
# $Revision: 1.18.1.5 $
#
package provide zircon 1.18
#
proc channelMonitor {net chan} { $net monitor $chan }
#
proc updateMon {net chid names} {
    set w .@mon$chid
    if ![winfo exists $w] {makeMon $net $chid $names ; return}
    set win $w.users.userList
    set xist {}
    foreach n [winfo children $win] { lappend xist [winfo name $n] }
    foreach n $names {
	switch {} $n continue
	regexp {^([@+]?)(.*)} $n m mrk n
	switch $mrk {
	@ { set mrk operator} 
	+ { set mrk speaker}
	}
	set usr [User :: make $net $n]
	if ![winfo exists [set winu $win.$usr]] {
	    wsortIns nil $win $n $usr
	    $usr ref
	} {
	    if ![normal $winu] {
		$winu configure -state normal
		$usr heal
	    }
	    listkill xist $usr
	}
	markButton $winu $mrk
    }
    foreach n $xist {if [normal $win.$n] {destroy $win.$n ; $n deref}}
}
#
proc makeMon {net chid names} {
    set w .@mon$chid
    toplevel $w -class Zircon
    set chan [$chid name]
    wm title $w "$chan [trans monitor]"
    wm resizable $w 0 1
    wm protocol $w WM_DELETE_WINDOW "deMonitor $net $chid 1"
 
    pack [frame $w.btns -relief raised] -side bottom -fill x
    pack [set wu [frame $w.users -relief raised]] -fill y
    scrollbar $wu.vscroller -command "$wu.userList yview" 
    set win [text $wu.userList -yscrollcommand "bsSet $wu.vscroller" \
      -relief flat -borderwidth 0 -width 14 -height 10]
    pack $wu.userList $wu.vscroller -side left -fill y -expand 1
    button $w.btns.cancel -text [trans dismiss] \
      -command "deMonitor $net $chid 1" -width 5
    button $w.btns.join -text [trans join] \
      -command " $chid sendJoin {} " -width 5
    pack $w.btns.cancel $w.btns.join -side left -fill x -expand 1
    foreach n $names {
	regexp {^([@+]?)(.*)} $n m mrk n
	switch $mrk {
	@ { set mrk operator} 
	+ { set mrk speaker}
	}
	set usr [User :: make $net $n]
	set winu $win.$usr
	if ![winfo exists $winu] {
	    wsortIns nil $win $n $usr
	    $usr ref
	    markButton $winu $mrk
	}
    }
}
